package cokr.xit.fims.epst.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CmmnUtil;
import cokr.xit.fims.epst.EpostGdntc;
import cokr.xit.fims.epst.EpostQuery;
import cokr.xit.fims.epst.dao.EpostGdntcMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**전자우편 안내문 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-12-04	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("epostGdntcBean")
public class EpostGdntcBean extends AbstractBean {

	/** 전자우편 안내문 정보 DAO */
	@Resource(name = "epostGdntcMapper")
	private EpostGdntcMapper epostGdntcMapper;

	/**지정한 조건에 따라 전자우편 안내문 목록을 조회하여 반환한다.
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 목록
	 */
	public List<DataObject> getEpostGdntcList(EpostQuery req) {
		// 사용 여부 확인
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			if (req.getBy() == null) {
				req.setOrderBy("REG_DT");
			} else {
				req.setOrderBy(CmmnUtil.convertCamelCaseToSnakeCase(req.getBy()));
			}
		}

		return epostGdntcMapper.selectEpostGdntcList(req);
	}

	/**지정한 조건에 따라 전자우편 안내문 객체들을 반환한다.
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 객체 목록
	 */
	public List<DataObject> getEpostGdntcs(EpostQuery req) {
		// 사용 여부 확인
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}
		if (req.getOrderBy() == null) {
			req.setOrderBy("EG.GDNTC_ID DESC");
		}

		return epostGdntcMapper.selectEpostGdntcs(req);
	}

	/**지정한 조건에 따라 전자우편 안내문 정보를 반환한다.
	 * @param req 전자우편 안내문 조회 조건
	 * @return 전자우편 안내문 정보
	 */
	public DataObject getEpostGdntcInfo(EpostQuery req) {
		DataObject dataInfo = new DataObject();

		if (req.getCallPurpose().equals("create")) {
			dataInfo.set("SGG_CD", req.getSggCd());
			dataInfo.set("TASK_SE_CD", req.getTaskSeCd());
		} else {
			dataInfo = epostGdntcMapper.selectEpostGdntcInfo(req);;
		}

		return dataInfo;
	}

	/**전자우편 안내문 정보를 등록한다.
	 * @param epostGdcc 전자우편 안내문
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String createEpostGdntc(EpostGdntc epostGdntc) {
		// 전자우편안내문(TB_EPOST_GDNTC) 정보를 등록한다.
		int rtnNocs = epostGdntcMapper.insertEpostGdntc(epostGdntc);
		if (rtnNocs != 1) {
			throw new RuntimeException("전자우편 안내문 정보 등록에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**전자우편 안내문 정보를 수정한다.
	 * @param epostGdcc 전자우편 안내문
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String updateEpostGdntc(EpostGdntc epostGdntc) {
		// 전자우편안내문(TB_EPOST_GDNTC) 정보를 수정한다.
		int rtnNocs = epostGdntcMapper.updateEpostGdntc(epostGdntc);
		if (rtnNocs != 1) {
			throw new RuntimeException("전자우편 안내문 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**전자우편 안내문 정보를 삭제한다.
	 * @param epostGdcc 전자우편 안내문
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String removeEpostGdntc(EpostGdntc epostGdntc) {
		// 전자우편안내문(TB_EPOST_GDNTC) 정보를 삭제한다.
		int rtnNocs = epostGdntcMapper.deleteEpostGdntc(epostGdntc);
		if (rtnNocs < 1) {
			throw new RuntimeException("전자우편 안내문 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

}
